/*---------------------------------------------------------------
This file is part of the Buildable Evolution Software Project. 

http://www.demo.cs.brandeis.edu/pr/buildable
(C) Pablo Funes and Jordan B. Pollack 1997-2008
pablo@cs.brandeis.edu

The methods and configurations incorporated in the Builable Evolution
Software Project are covered in part by United States patent
6,434,492 "Computer apparatus and method for analyzing structural
stability" of August 13, 2002. 

The Buildable Evolution Software Project is free software: you 
can redistribute it and/or modify it under the terms of the 
GNU General Public License as published by the Free Software 
Foundation, either version 3 of the License, or (at your option) 
any later version. 

The Buildable Evolution Software Project is distributed in the
hope that it will be useful, but WITHOUT ANY WARRANTY; without
even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more
details. 

You should have received a copy of the GNU General Public License 
along with the software. If not, see <http://www.gnu.org/licenses/>. 
---------------------------------------------------------------*/

/* #define PARALLEL */


#define PROCESSORS 16



/* #define CHECKS  */

#ifdef PARALLEL
#include <ulocks.h>
#include <task.h>
#include <mutex.h>
#endif

#ifdef PARALLEL

#define WHOAM(file) fprintf(file,"(%d)",m_get_myid());
#define WHOAMI WHOAM(stdout)
#define WHOAM2 WHOAM(stderr)
#define ONEFOREACH [PROCESSORS]
#define MINE [myid]
#define USEMINE  int myid=m_get_myid();
#define LOCK my_lock();
#define UNLOCK my_unlock();
#define PARK 
#define UNPARK 
#define LOCAL
#define WRITE_LOCK 0x10000
#define READ_LOCK 0x1
#define TO_WRITE ,1
#define TO_READ ,0
#define LOCK_PARAM ,int to_write
#define INCREMENT(var) test_then_add(&(var),1)
/* #define KILL m_kill_procs(); */
#define KILL
#else

#define WHOAM
#define WHOAMI
#define WHOAM2
#define ONEFOREACH
#define MINE
#define USEMINE
#define LOCK
#define UNLOCK
#define PARK
#define KILL
#define UNPARK
#define LOCAL static
#define TO_WRITE
#define TO_READ
#define LOCK_PARAM
#define INCREMENT(var) (var)++;
#endif

